package j2d;

import j2d.border.BorderUtils;
import j2d.color.FloatImageBean;
import utils.ResourceManager;

import java.awt.*;

import math.fourierTransforms.pfa.PFAImage;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Mar 6, 2006
 * Time: 2:17:58 PM
 */
public class SpatialCorrelationOld {
    public static void main(String[] args) {
        spatialCorrelationTestPFA();
    }
    private static void spatialCorrelationTestPFA() {
            ResourceManager rm = ResourceManager.getResourceManager();
            Image scene = ImageUtils.getImage(rm.getImageFile("baboon.JPEG"));
            //ImageUtils.displayImage(scene,"monkey see");
            Image template = ImageUtils.getImage(rm.getImageFile("baboon_eye.gif"));
            // ImageUtils.displayImage(template,"monkey eye");
            Image imgAns = getSpatialCorrelationPFA(template, scene);
            ImageUtils.displayImage(imgAns, "answer");
        }

    private static void spatialCorrelationTest() {
        ResourceManager rm = ResourceManager.getResourceManager();
        Image scene = ImageUtils.getImage(rm.getImageFile("baboon.JPEG"));
        //ImageUtils.displayImage(scene,"monkey see");
        Image template = ImageUtils.getImage(rm.getImageFile("eye.gif"));
        // ImageUtils.displayImage(template,"monkey eye");
        Image imgAns = getSpatialCorrelation(template, scene);
        ImageUtils.displayImage(imgAns, "answer");
    }

    /**
     * Correlate imag1 with img2 and return the new image.
     * This is very slow correlation, but it works well.
     *
     * @param templateImage
     * @param sceneImage
     * @return correlation output
     */
    //todo For hw6, refactor the getSpatialCorrelation Code so that
    // it uses the FloatImageBean and the ShortImageBean. Do NOT
    // use float[][] or int[][] or short[][]
    // be sure to test your code using the HW5.main
    // you might want to improve your test to make sure that
    // unit testing is correct!
    public static Image getSpatialCorrelation(Image templateImage, Image sceneImage) {
        // Find min and max of template
        ShortImageBean templateSib = new ShortImageBean(templateImage);
        ShortImageBean grownSib = new ShortImageBean(sceneImage);

        MinMax2D mmTemplate = templateSib.getMinMax2DForBorder();

        //todo use FloatImageBean here.
        FloatImageBean templateFib = new FloatImageBean(
                getTemplate(mmTemplate, templateSib.getR()),
                getTemplate(mmTemplate, templateSib.getG()),
                getTemplate(mmTemplate, templateSib.getB()));

        // Now, remove template average
        templateFib.removeTheDcComponent();

        FloatImageBean grownFib = new FloatImageBean(sceneImage);
        int wo = grownFib.getWidth();
        int ho = grownFib.getHeight();

        int tH = templateFib.getHeight();
        int tW = templateFib.getWidth();
        // Create New Grown Image Grow Image by template size
        int wi = wo + tW;
        int hi = ho + tH;
        int left = tW / 2;
        int top = tH / 2;
        int bottom = tH - top;
        int right = tW - left;
        Image grownImage = BorderUtils.getBorderImage(
                sceneImage,
                left, right, top, bottom, BorderUtils.BORDER_REFLECT);
        grownSib = new ShortImageBean(grownImage);

        double rMax = correlate(wi, tW, hi, tH, templateFib.getR(), grownSib.getR(), grownFib.getR());
        double gMax = correlate(wi, tW, hi, tH, templateFib.getG(), grownSib.getG(), grownFib.getG());
        double bMax = correlate(wi, tW, hi, tH, templateFib.getB(), grownSib.getB(), grownFib.getB());

        // Apply Simple scale to output
        float scale = 255 / (float) Math.max(rMax, Math.max(gMax, bMax));
        FloatImageBean fib = new FloatImageBean(grownFib.getR(), grownFib.getG(), grownFib.getB());
        fib.scale(scale);
        return fib.getImage();
    }

    private static float[][] getTemplate(MinMax2D mm, short[][] r) {
        Dimension mmSize = mm.getSize();
        float[][] rt = new float[mmSize.width][mmSize.height];
        for (int x11 = 0; x11 < mmSize.width; x11++) {
            for (int y1 = 0; y1 < mmSize.height; y1++) {
                rt[x11][y1] = r[x11 + mm.getMinX()][y1 + mm.getMinY()];
            }
        }
        return rt;
    }
     private static double correlate(int wi, int tW, int hi, int tH,
                                     float[][] rt,
                                     short[][] ri,
                                     float[][] ro) {
        double rSum;
        // other necessary constants
        double rMax = 0;
        // Perform correlation
        for (int x14 = 0; x14 < wi - tW; x14++) {
            for (int y1 = 0; y1 < hi - tH; y1++) {
                rSum = 0;
                for (int tx = 0; tx < tW; tx++)
                    for (int ty = 0; ty < tH; ty++)
                        rSum += rt[tx][ty] * ri[tx + x14][ty + y1];
                rSum /= tW * tH;
                rMax = Math.max(rMax, rSum);
                ro[x14][y1] = (float) (Math.max(0, rSum));
            }
        }
        return rMax;
    }
    public static double correlatebad(int wi, int tW, int hi, int tH,
                                      float[][] rt,
                                      short[][] ri,
                                      float[][] ro) {
        double rSum;
        // other necessary constants
        // Perform correlation
        for (int u = 0; u < wi - tW; u++) {
            for (int v = 0; v < hi - tH; v++) {
                double a = 0;
                rSum = 0;
                for (int tx = 0; tx < tW; tx++)
                    for (int ty = 0; ty < tH; ty++) {
                        //rSum += rt[tx][ty] * ri[tx + u][ty + v];
                        a = a + ri[tx +u][ty + v];
                    }
                a = a / tW * tH;
                for (int tx = 0; tx < tW; tx++)
                    for (int ty = 0; ty < tH; ty++) {
                        double fp = ri[tx + u][ty + v] - a;
                        double tp = rt[tx][ty];
                        rSum += tp * fp / (.5*(tp*tp * fp * fp));
                    }
                ;

                ro[u][v] = (float) (Math.max(0, rSum));
            }
        }
        return 0;
    }

    /**
     * Correlate imag1 with img2 and return the new image.
     * This is very slow correlation, but it works well.
     *
     * @return correlation output
     */
//todo debug and test this getSpatialCorrelation method
    public static short[][] getSpatialCorrelation(short a[][], short b[][]) {

        ShortImageBean image1Sib = new ShortImageBean(a, a, a);
        ShortImageBean image2Sib = new ShortImageBean(b, b, b);
        Image ans = getSpatialCorrelation(image1Sib.getImage(), image2Sib.getImage());
        ShortImageBean ansSib = new ShortImageBean(ans);
        return ansSib.getR();
    }

    /**
     * Correlate imag1 with img2 and return the new image.
     * This is very slow correlation, but it works well.
     *
     * @param templateImage
     * @param sceneImage
     * @return correlation output
     */
//todo For hw6, refactor the getSpatialCorrelation Code so that
// it uses the FloatImageBean and the ShortImageBean. Do NOT
// use float[][] or int[][] or short[][]
// be sure to test your code using the HW5.main
// you might want to improve your test to make sure that
// unit testing is correct!
// this is the old one
    public static Image getSpatialCorrelationOld(Image templateImage, Image sceneImage) {
        // Find min and max of template
        ShortImageBean templateSib = new ShortImageBean(templateImage);
        ShortImageBean grownSib = new ShortImageBean(sceneImage);

        MinMax2D mmTemplate = templateSib.getMinMax2DForBorder();

        Dimension mmSize = mmTemplate.getSize();
        //todo use FloatImageBean here.
        float[][] rt = getTemplate(mmTemplate, templateSib.getR());

        float[][] gt = getTemplate(mmTemplate, templateSib.getG());

        float[][] bt = getTemplate(mmTemplate, templateSib.getB());
        FloatImageBean templateFib = new FloatImageBean(rt, gt, bt);

        // Now, remove template average
        templateFib.removeTheDcComponent();


        int wo = grownSib.getWidth();
        int ho = grownSib.getHeight();
        Dimension d = new Dimension(wo, ho);
        // Create blank output arrays of same size as image
        //todo use FloatImageBean here.
        float[][] ro = new float[wo][ho];
        float[][] go = new float[wo][ho];
        float[][] bo = new float[wo][ho];
        int tH = mmTemplate.getMaxY() - mmTemplate.getMinY() + 1;
        int tW = mmTemplate.getMaxX() - mmTemplate.getMinX() + 1;
        // Create New Grown Image Grow Image by template size
        int wi = wo + tW;
        int hi = ho + tH;
        int left = tW / 2;
        int top = tH / 2;
        int bottom = tH - top;
        int right = tW - left;
        Image grownImage = BorderUtils.getBorderImage(
                sceneImage,
                left, right, top, bottom, BorderUtils.BORDER_REFLECT);
        grownSib = new ShortImageBean(grownImage);

        double rMax = correlate(wi, tW, hi, tH, rt, grownSib.getR(), ro);
        double gMax = correlate(wi, tW, hi, tH, gt, grownSib.getG(), go);
        double bMax = correlate(wi, tW, hi, tH, bt, grownSib.getB(), bo);

        // Apply Simple scale to output
        float scale = 255 / (float) Math.max(rMax, Math.max(gMax, bMax));
        FloatImageBean fib = new FloatImageBean(ro, go, bo);
        fib.scale(scale);
        return fib.getImage();

    }

    /**
     * Correlate imag1 with img2 and return the new image.
     * This is very slow correlation, but it works well.
     *
     * @param img1
     * @param img2
     * @return correlation output
     */
    public static Image getSpatialCorrelationGood(Image img1, Image img2) {

        // Find min and max of template
        ShortImageBean image1Sib = new ShortImageBean(img1);
        ShortImageBean image2Sib = new ShortImageBean(img2);
        short[][] r = image1Sib.getR();
        short[][] g = image1Sib.getG();
        short[][] b = image1Sib.getB();
        int minX = 1000000000;
        int maxX = 0;
        int minY = 1000000000;
        int maxY = 0;
        int W = image1Sib.getWidth();
        int H = image1Sib.getHeight();
        int tmp = 0;

        for (int x1 = 0; x1 < W; x1++) {
            for (int y1 = 0; y1 < H; y1++) {
                tmp = r[x1][y1] + g[x1][y1] + b[x1][y1];
                if (tmp > 0) {
                    minX = Math.min(x1, minX);
                    maxX = Math.max(x1, maxX);
                    minY = Math.min(y1, minY);
                    maxY = Math.max(y1, maxY);
                }
            }
        }
        // Create the template arrays
        int tH = maxY - minY + 1;
        int tW = maxX - minX + 1;
        double rSum = 0;
        double gSum = 0;
        double bSum = 0;
        float[][] rt = new float[tW][tH];
        float[][] gt = new float[tW][tH];
        float[][] bt = new float[tW][tH];
        for (int x11 = 0; x11 < tW; x11++) {
            for (int y1 = 0; y1 < tH; y1++) {
                rSum += rt[x11][y1] = r[x11 + minX][y1 + minY];
                gSum += gt[x11][y1] = g[x11 + minX][y1 + minY];
                bSum += bt[x11][y1] = b[x11 + minX][y1 + minY];

            }
        }

        // Now, remove template average

        float rAvg = (float) (rSum / (tW * tH));
        float gAvg = (float) (gSum / (tW * tH));
        float bAvg = (float) (bSum / (tW * tH));
        for (int x12 = 0; x12 < tW; x12++) {
            for (int y1 = 0; y1 < tH; y1++) {
                rt[x12][y1] -= rAvg;
                gt[x12][y1] -= gAvg;
                bt[x12][y1] -= bAvg;
            }
        }

        // and generate image of template so we can se what we got
        short[][] rr = new short[tW][tH];
        short[][] gg = new short[tW][tH];
        short[][] bb = new short[tW][tH];
        for (int x13 = 0; x13 < tW; x13++) {
            for (int y1 = 0; y1 < tH; y1++) {
                rr[x13][y1] = (short) (Math.max(0, rt[x13][y1]));
                gg[x13][y1] = (short) (Math.max(0, gt[x13][y1]));
                bb[x13][y1] = (short) (Math.max(0, bt[x13][y1]));
            }
        }
        ShortImageBean template = new ShortImageBean(rr, gg, bb);
        ImageUtils.displayImage(template.getImage(), "template");

        // get input image info

        int wo = image2Sib.getWidth();
        int ho = image2Sib.getHeight();
        Dimension d = new Dimension(wo, ho);
        // Create blank output arrays of same size as image
        float[][] ro = new float[wo][ho];
        float[][] go = new float[wo][ho];
        float[][] bo = new float[wo][ho];

        // Create New Grown Image Grow Image by template size
        int wi = wo + tW;
        int hi = ho + tH;
        int left = tW / 2;
        int top = tH / 2;
        int bottom = tH - top;
        int right = tW - left;
        Image grownImage = BorderUtils.getBorderImage(
                img2,
                left, right, top, bottom, BorderUtils.BORDER_REFLECT);
        image2Sib = new ShortImageBean(grownImage);
        short[][] ri = image2Sib.getR();
        short[][] gi = image2Sib.getG();
        short[][] bi = image2Sib.getB();

        // other necessary constants
        double rMax = 0;
        double gMax = 0;
        double bMax = 0;

        // Perform correlation
        for (int x14 = 0; x14 < wi - tW; x14++) {
            for (int y1 = 0; y1 < hi - tH; y1++) {
                rSum = 0;
                gSum = 0;
                bSum = 0;
                for (int tx = 0; tx < tW; tx++)
                    for (int ty = 0; ty < tH; ty++) {
                        rSum += rt[tx][ty] * ri[tx + x14][ty + y1];
                        gSum += gt[tx][ty] * gi[tx + x14][ty + y1];
                        bSum += bt[tx][ty] * bi[tx + x14][ty + y1];
                    }

                rSum /= tW * tH;
                gSum /= tW * tH;
                bSum /= tW * tH;
                rMax = Math.max(rMax, rSum);
                gMax = Math.max(gMax, gSum);
                bMax = Math.max(bMax, bSum);
                ro[x14][y1] = (float) (Math.max(0, rSum));
                go[x14][y1] = (float) (Math.max(0, gSum));
                bo[x14][y1] = (float) (Math.max(0, bSum));
            }
        }

        // Apply Simple scale to output
        float scale = 255 / (float) Math.max(rMax, Math.max(gMax, bMax));
        short[][] rs = new short[wo][ho];
        short[][] gs = new short[wo][ho];
        short[][] bs = new short[wo][ho];

        for (int x15 = 0; x15 < wo; x15++) {
            for (int y1 = 0; y1 < ho; y1++) {
                rs[x15][y1] = (short) (scale * ro[x15][y1]);
                gs[x15][y1] = (short) (scale * go[x15][y1]);
                bs[x15][y1] = (short) (scale * bo[x15][y1]);
            }
        }

        ShortImageBean answerSib = new ShortImageBean(rs, gs, bs);
        return answerSib.getImage();
    }

    // todo fix this for your midterm!
    // todo want a normalized spatial correlation using the
    // todo prime factor algorithm.
    public static Image getSpatialCorrelationPFA(Image img2, Image img1) {
        // Anne MacIlvain
        // The correlation of a[n] with b[n] is
        // a[n] * b[-n] = c[n], in the time domain.
        // "That is, flipping b[n] left-for-right is
        // accomplished by reversing the sign of the
        // index, i.e., b [-n].
        // So flip the image in the time domain, before
        // working in the frequency domain.

        PFAImage p1 = new PFAImage(img1);
        PFAImage p2 = new PFAImage(ImageUtils.rotate180(img2));
        //p2.removeDcComponent();
        //p1.removeDcComponent();
        p1.fft();
        p2.fft();
        // you could zero out the dc component in the frequency domain
        // by setting to zero the values at the center of the image.
        // Do this for both the real and the imaginary parts.
        // you will still need to scale your real numbers into range.
        p1.multiply(p2);

        p1.ifft();
        //todo figure out what the range is for the min and max on
        // the input images and scale properly.
        //p1.scaleIntoRange();
        return p1.getImage();
    }
    public static void testRotate180(){
        ResourceManager rm = ResourceManager.getResourceManager();
        ImageUtils.displayImage(
                ImageUtils.rotate180(
                        ImageUtils.getImage(
                                rm.getImageFile("baboon.JPEG"))),"flip");

    }
}
