package j2d.gui.menu;

import gui.run.RunMenu;
import gui.run.RunMenuItem;

import javax.swing.*;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Nov 2, 2005
 * Time: 5:48:45 PM
 */
public class ProcessMenu {


    public static void addProcessMenu(
            final j2d.gui.Main main, JMenuBar mb) {
        mb.add(EditMenu.getEditMenu(main));
        RunMenu processMenu = new RunMenu("[process");
        processMenu.add(HistogramMenu.getHistogramMenu(main));
        processMenu.add(ColorMenu.getColorMenu(main));
        processMenu.add(FilterMenu.getFilterMenu(main));
        processMenu.add(new ShapeMenu(main));
        HppMenu.addHppMenu(processMenu, main);
        mb.add(processMenu);
        processMenu.add(
                new RunMenuItem("[Apply{control A}") {
                    public void run() {
                        main.apply();
                    }
                });
        processMenu.add(new RunMenuItem("[Data {control D}"){
            public void run(){
                     main.displayDataWindow();
            }
        });
    }

}
